#qmake option
CONFIG += release
CONFIG += qt

MOC_DIR      = moc
OBJECTS_DIR  = obj
DESTDIR      = release
UI_DIR       = ui

TEMPLATE = app

TARGET = "SPECTRO_IR"


########################################
#CONFIGURATION qextserialport
INCLUDEPATH += ./qextserialport/include/
DEPENDPATH  += ./qextserialport/include/
LIBS          += -L./qextserialport/lib/ -lqextserialport
unix:DEFINES   = _TTY_POSIX_
win32:DEFINES  = _TTY_WIN_ QWT_DLL QT_DLL
########################################


########################################
#CONFIGURATION SDL
INCLUDEPATH += ./SDL/include/
DEPENDPATH  += ./SDL/include/
LIBS          += -L./SDL/lib/ -lSDL
########################################


########################################
#CONFIGURATION QWT
INCLUDEPATH += ./qwt/include/
DEPENDPATH  += ./qwt/include/
QMAKE_LIBS_QWT += -L./qwt/lib/ -lqwt
LIBS += $$QMAKE_LIBS_THREAD $$QMAKE_LIBS_QWT
########################################


########################################
#CONFIGURATION Dx2Asc
INCLUDEPATH += ./Dx2Asc/
DEPENDPATH  += ./Dx2Asc/
LIBS          += -L./Dx2Asc/jcamp.lib
########################################


FORMS       = quadstar.ui 
HEADERS     = quadstar.h jcamp1.h plot.h delegate.h
RESOURCES   = quadstarbuilder.qrc
RC_FILE     = urbidev.rc
SOURCES     = quadstar.cpp quadstar_page1.cpp quadstar_page2.cpp quadstar_page3.cpp quadstar_page4.cpp main.cpp jcamp1.cpp plot.cpp delegate.cpp

