// La page 3 concerne tout ce qui touche a l'affichage des donnees

////////////////////////////////////////
// chargement des valeurs
void QuadStar::chargement_valeurs()
{

// on redimensionne la fenetre
  visionGraph.setAxisScale(QwtPlot::xBottom, 4400, 450);
  visionGraph.setAxisScale(QwtPlot::yLeft, -10, 10);
  visionGraph.valmax = 0;
  visionGraph.valmin = 0;

  visionGraph.pointsAAfficher = 1976;

  visionGraph.videPlot( ); // on libere la memoire

  visionGraph.abscisse( ); // on remplit l'axe des abscisses

  // on remplit les tableaux
  QFile file;
  double value;
  int i=0;
  file.setFileName("data/0.TXT");
  if( file.exists() )
  {
    file.open(QIODevice::ReadOnly | QIODevice::Text );
    QTextStream in(&file);
    QString line;
    while (!in.atEnd() && i < 1978) 
  {
    line = in.readLine(); 
    line.remove(0, line.indexOf(";")+1 );
    value = line.toDouble();
    visionGraph.val1[i]=value;
    if(value > visionGraph.valmax)
      visionGraph.valmax=value;
    if(value < visionGraph.valmin)
      visionGraph.valmin=value;

    // Enregistrement dans le tableur
    QModelIndex index = model->index(i, 2, QModelIndex());
    model->setData(index, QVariant(value));

    i++;
  }
  // fermeture des fichiers
  file.close();
  }


  i=0;
  file.setFileName("data/10.TXT");
  if( file.exists() )
  {
    file.open(QIODevice::ReadOnly | QIODevice::Text );
    QTextStream in(&file);
    QString line;
    while (!in.atEnd() && i < 1978) 
  {
    line = in.readLine(); 
    line.remove(0, line.indexOf(";")+1 );
    value = line.toDouble();
    visionGraph.val2[i]=value;
    if(value > visionGraph.valmax)
      visionGraph.valmax=value;
    if(value < visionGraph.valmin)
      visionGraph.valmin=value;

    // Enregistrement dans le tableur
    QModelIndex index = model->index(i, 3, QModelIndex());
    model->setData(index, QVariant(value));

    i++;
  }
  // fermeture des fichiers
  file.close();
  }

  i=0;
  file.setFileName("data/INCONNU.TXT");
  if( file.exists() )
  {
    file.open(QIODevice::ReadOnly | QIODevice::Text );
    QTextStream in(&file);
    QString line;
    while (!in.atEnd() && i < 1978) 
  {
    line = in.readLine(); 
    line.remove(0, line.indexOf(";")+1 );
    value = line.toDouble();
    visionGraph.val3[i]=value;
    if(value > visionGraph.valmax)
      visionGraph.valmax=value;
    if(value < visionGraph.valmin)
      visionGraph.valmin=value;

    // Enregistrement dans le tableur
    QModelIndex index = model->index(i, 4, QModelIndex());
    model->setData(index, QVariant(value));

    i++;
  }
  // fermeture des fichiers
  file.close();
  }


  i=0;
  file.setFileName("data/20.TXT");
  if( file.exists() )
  {
    file.open(QIODevice::ReadOnly | QIODevice::Text );
    QTextStream in(&file);
    QString line;
    while (!in.atEnd() && i < 1978) 
  {
    line = in.readLine(); 
    line.remove(0, line.indexOf(";")+1 );
    value = line.toDouble();
    visionGraph.val4[i]=value;
    if(value > visionGraph.valmax)
      visionGraph.valmax=value;
    if(value < visionGraph.valmin)
      visionGraph.valmin=value;

    // Enregistrement dans le tableur
    QModelIndex index = model->index(i, 5, QModelIndex());
    model->setData(index, QVariant(value));

    i++;
  }
  // fermeture des fichiers
  file.close();
  }

  i=0;
  file.setFileName("data/A.TXT");
  if( file.exists() )
  {
    file.open(QIODevice::ReadOnly | QIODevice::Text );
    QTextStream in(&file);
    QString line;
    while (!in.atEnd() && i < 1978) 
  {
    line = in.readLine(); 
    line.remove(0, line.indexOf(";")+1 );
    value = line.toDouble();
    visionGraph.val5[i]=value;
    if(value > visionGraph.valmax)
      visionGraph.valmax=value;
    if(value < visionGraph.valmin)
      visionGraph.valmin=value;

    // Enregistrement dans le tableur
    QModelIndex index = model->index(i, 6, QModelIndex());
    model->setData(index, QVariant(value));

    i++;
  }
  // fermeture des fichiers
  file.close();
  }

  i=0;
  file.setFileName("data/B.TXT");
  if( file.exists() )
  {
    file.open(QIODevice::ReadOnly | QIODevice::Text );
    QTextStream in(&file);
    QString line;
    while (!in.atEnd() && i < 1978) 
  {
    line = in.readLine(); 
    line.remove(0, line.indexOf(";")+1 );
    value = line.toDouble();
    visionGraph.val6[i]=value;
    if(value > visionGraph.valmax)
      visionGraph.valmax=value;
    if(value < visionGraph.valmin)
      visionGraph.valmin=value;

    // Enregistrement dans le tableur
    QModelIndex index = model->index(i, 7, QModelIndex());
    model->setData(index, QVariant(value));

    i++;
  }
  // fermeture des fichiers
  file.close();
  }

  i=0;
  file.setFileName("data/C.TXT");
  if( file.exists() )
  {
    file.open(QIODevice::ReadOnly | QIODevice::Text );
    QTextStream in(&file);
    QString line;
    while (!in.atEnd() && i < 1978) 
  {
    line = in.readLine(); 
    line.remove(0, line.indexOf(";")+1 );
    value = line.toDouble();
    visionGraph.val7[i]=value;
    if(value > visionGraph.valmax)
      visionGraph.valmax=value;
    if(value < visionGraph.valmin)
      visionGraph.valmin=value;

    // Enregistrement dans le tableur
    QModelIndex index = model->index(i, 8, QModelIndex());
    model->setData(index, QVariant(value));

    i++;
  }
  // fermeture des fichiers
  file.close();
  }

  i=0;
  file.setFileName("data/D.TXT");
  if( file.exists() )
  {
    file.open(QIODevice::ReadOnly | QIODevice::Text );
    QTextStream in(&file);
    QString line;
    while (!in.atEnd() && i < 1978) 
  {
    line = in.readLine(); 
    line.remove(0, line.indexOf(";")+1 );
    value = line.toDouble();
    visionGraph.val8[i]=value;
    if(value > visionGraph.valmax)
      visionGraph.valmax=value;
    if(value < visionGraph.valmin)
      visionGraph.valmin=value;

    // Enregistrement dans le tableur
    QModelIndex index = model->index(i, 9, QModelIndex());
    model->setData(index, QVariant(value));

    i++;
  }
  // fermeture des fichiers
  file.close();
  }

  i=0;
  file.setFileName("data/BACKGROUND.TXT");
  if( file.exists() )
  {
    file.open(QIODevice::ReadOnly | QIODevice::Text );
    QTextStream in(&file);
    QString line;
    while (!in.atEnd() && i < 1978) 
  {
    line = in.readLine(); 
    line.remove(0, line.indexOf(";")+1 );
    value = line.toDouble();
    visionGraph.val9[i]=value;
    if(value > visionGraph.valmax)
      visionGraph.valmax=value;
    if(value < visionGraph.valmin)
      visionGraph.valmin=value;

    // Enregistrement dans le tableur
    QModelIndex index = model->index(i, 0, QModelIndex());
    model->setData(index, QVariant(value));

    i++;
  }
  // fermeture des fichiers
  file.close();
  }

  i=0;
  file.setFileName("data/CUVE_VIDE.TXT");
  if( file.exists() )
  {
    file.open(QIODevice::ReadOnly | QIODevice::Text );
    QTextStream in(&file);
    QString line;
    while (!in.atEnd() && i < 1978) 
  {
    line = in.readLine(); 
    line.remove(0, line.indexOf(";")+1 );
    value = line.toDouble();
    visionGraph.val10[i]=value;
    if(value > visionGraph.valmax)
      visionGraph.valmax=value;
    if(value < visionGraph.valmin)
      visionGraph.valmin=value;

    // Enregistrement dans le tableur
    QModelIndex index = model->index(i, 1, QModelIndex());
    model->setData(index, QVariant(value));

    i++;
  }
  // fermeture des fichiers
  file.close();
  }

 // Creation de A - CCL4
  QFile file_ccl4;
  file_ccl4.setFileName("data/0.TXT");
  if( file_ccl4.exists() )
  {

    file.setFileName("data/A.TXT");
    if( file.exists() )
    {

      file.open(QIODevice::ReadOnly | QIODevice::Text );
      file_ccl4.open(QIODevice::ReadOnly | QIODevice::Text );
      QTextStream in(&file);
      QTextStream in_ccl4(&file_ccl4);
      QString line;
      QString line_ccl4;
      i=0;
      while (!in.atEnd() && !in_ccl4.atEnd() && i < 1978) 
      {
        line = in.readLine(); 
        line_ccl4 = in_ccl4.readLine(); 

        line.remove(0, line.indexOf(";")+1 );
        line_ccl4.remove(0, line_ccl4.indexOf(";")+1 );
        value = line.toDouble() - line_ccl4.toDouble();

        visionGraph.val11[i]=value;
        if(i >= 1770)
        visionGraph.val11[i]=0;

        if(value > visionGraph.valmax)
          visionGraph.valmax=value;
        if(value < visionGraph.valmin)
          visionGraph.valmin=value;

        // Enregistrement dans le tableur
        QModelIndex index = model->index(i, 10, QModelIndex());
        model->setData(index, QVariant(value));

        i++;
      }

      // fermeture des fichiers
      file.close();
      file_ccl4.close();

    } // fin du if A

    file.setFileName("data/B.TXT");
    if( file.exists() )
    {

      file.open(QIODevice::ReadOnly | QIODevice::Text );
      file_ccl4.open(QIODevice::ReadOnly | QIODevice::Text );
      QTextStream in(&file);
      QTextStream in_ccl4(&file_ccl4);
      QString line;
      QString line_ccl4;
      i=0;
      while (!in.atEnd() && !in_ccl4.atEnd() && i < 1978) 
      {
        line = in.readLine(); 
        line_ccl4 = in_ccl4.readLine(); 

        line.remove(0, line.indexOf(";")+1 );
        line_ccl4.remove(0, line_ccl4.indexOf(";")+1 );
        value = line.toDouble() - line_ccl4.toDouble();

        visionGraph.val12[i]=value;
        if(i >= 1770)
        visionGraph.val12[i]=0;

        if(value > visionGraph.valmax)
          visionGraph.valmax=value;
        if(value < visionGraph.valmin)
          visionGraph.valmin=value;

        // Enregistrement dans le tableur
        QModelIndex index = model->index(i, 11, QModelIndex());
        model->setData(index, QVariant(value));

        i++;
      }

      // fermeture des fichiers
      file.close();
      file_ccl4.close();

    } // fin du if B

    file.setFileName("data/C.TXT");
    if( file.exists() )
    {

      file.open(QIODevice::ReadOnly | QIODevice::Text );
      file_ccl4.open(QIODevice::ReadOnly | QIODevice::Text );
      QTextStream in(&file);
      QTextStream in_ccl4(&file_ccl4);
      QString line;
      QString line_ccl4;
      i=0;
      while (!in.atEnd() && !in_ccl4.atEnd() && i < 1978) 
      {
        line = in.readLine(); 
        line_ccl4 = in_ccl4.readLine(); 

        line.remove(0, line.indexOf(";")+1 );
        line_ccl4.remove(0, line_ccl4.indexOf(";")+1 );
        value = line.toDouble() - line_ccl4.toDouble();

        visionGraph.val13[i]=value;
        if(i >= 1770)
        visionGraph.val13[i]=0;

        if(value > visionGraph.valmax)
          visionGraph.valmax=value;
        if(value < visionGraph.valmin)
          visionGraph.valmin=value;

        // Enregistrement dans le tableur
        QModelIndex index = model->index(i, 12, QModelIndex());
        model->setData(index, QVariant(value));

        i++;
      }

      // fermeture des fichiers
      file.close();
      file_ccl4.close();

    } // fin du if C

    file.setFileName("data/D.TXT");
    if( file.exists() )
    {

      file.open(QIODevice::ReadOnly | QIODevice::Text );
      file_ccl4.open(QIODevice::ReadOnly | QIODevice::Text );
      QTextStream in(&file);
      QTextStream in_ccl4(&file_ccl4);
      QString line;
      QString line_ccl4;
      i=0;
      while (!in.atEnd() && !in_ccl4.atEnd() && i < 1978) 
      {
        line = in.readLine(); 
        line_ccl4 = in_ccl4.readLine(); 

        line.remove(0, line.indexOf(";")+1 );
        line_ccl4.remove(0, line_ccl4.indexOf(";")+1 );
        value = line.toDouble() - line_ccl4.toDouble();

        visionGraph.val14[i]=value;
        if(i >= 1770)
        visionGraph.val14[i]=0;

        if(value > visionGraph.valmax)
          visionGraph.valmax=value;
        if(value < visionGraph.valmin)
          visionGraph.valmin=value;

        // Enregistrement dans le tableur
        QModelIndex index = model->index(i, 13, QModelIndex());
        model->setData(index, QVariant(value));

        i++;
      }

      // fermeture des fichiers
      file.close();
      file_ccl4.close();

    } // fin du if D


  } // fin du if CCL4



  visionGraph.setAxisScale(QwtPlot::yLeft, visionGraph.valmin, visionGraph.valmax);

///////////////////////////////////////////////////////////////////////

// affichage de la position du curseur
  if( d_panner == NULL)
  {
/*
    d_panner = new QwtPlotPanner(visionGraph.canvas());
    d_panner->setMouseButton(Qt::MidButton);
*/
    d_picker = new QwtPlotPicker(QwtPlot::xBottom, QwtPlot::yLeft,  QwtPicker::PointSelection | QwtPicker::DragSelection, QwtPlotPicker::CrossRubberBand, QwtPicker::AlwaysOn, visionGraph.canvas());
    d_picker->setRubberBandPen(QColor(Qt::green));
    d_picker->setRubberBand(QwtPicker::CrossRubberBand);
    d_picker->setTrackerPen(QColor(Qt::black));
  }
//////////////////////////////////////////////////////////////////////////


// affichage des graphes
  if(state1 == 1)
  {
    visionGraph.courbe1->attach(&visionGraph);
    visionGraph.courbe1->setVisible(true);
  }
  else
  {
    visionGraph.courbe1->detach();
    visionGraph.courbe1->setVisible(false);
  }
  if(state2 == 1)
  {
    visionGraph.courbe2->attach(&visionGraph);
    visionGraph.courbe2->setVisible(true);
  }
  else
  {
    visionGraph.courbe2->detach();
    visionGraph.courbe2->setVisible(false);
  }
  if(state3 == 1)
  {
    visionGraph.courbe3->attach(&visionGraph);
    visionGraph.courbe3->setVisible(true);
  }
  else
  {
    visionGraph.courbe3->detach();
    visionGraph.courbe3->setVisible(false);
  }
  if(state4 == 1)
  {
    visionGraph.courbe4->attach(&visionGraph);
    visionGraph.courbe4->setVisible(true);
  }
  else
  {
    visionGraph.courbe4->detach();
    visionGraph.courbe4->setVisible(false);
  }
  if(state5 == 1)
  {
    visionGraph.courbe5->attach(&visionGraph);
    visionGraph.courbe5->setVisible(true);
  }
  else
  {
    visionGraph.courbe5->detach();
    visionGraph.courbe5->setVisible(false);
  }
  if(state6 == 1)
  {
    visionGraph.courbe6->attach(&visionGraph);
    visionGraph.courbe6->setVisible(true);
  }
  else
  {
    visionGraph.courbe6->detach();
    visionGraph.courbe6->setVisible(false);
  }
  if(state7 == 1)
  {
    visionGraph.courbe7->attach(&visionGraph);
    visionGraph.courbe7->setVisible(true);
  }
  else
  {
    visionGraph.courbe7->detach();
    visionGraph.courbe7->setVisible(false);
  }
  if(state8 == 1)
  {
    visionGraph.courbe8->attach(&visionGraph);
    visionGraph.courbe8->setVisible(true);
  }
  else
  {
    visionGraph.courbe8->detach();
    visionGraph.courbe8->setVisible(false);
  }
  if(state9 == 1)
  {
    visionGraph.courbe9->attach(&visionGraph);
    visionGraph.courbe9->setVisible(true);
  }
  else
  {
    visionGraph.courbe9->detach();
    visionGraph.courbe9->setVisible(false);
  }
  if(state10 == 1)
  {
    visionGraph.courbe10->attach(&visionGraph);
    visionGraph.courbe10->setVisible(true);
  }
  else
  {
    visionGraph.courbe10->detach();
    visionGraph.courbe10->setVisible(false);
  }
  if(state11 == 1)
  {
    visionGraph.courbe11->attach(&visionGraph);
    visionGraph.courbe11->setVisible(true);
  }
  else
  {
    visionGraph.courbe11->detach();
    visionGraph.courbe11->setVisible(false);
  }
  if(state12 == 1)
  {
    visionGraph.courbe12->attach(&visionGraph);
    visionGraph.courbe12->setVisible(true);
  }
  else
  {
    visionGraph.courbe12->detach();
    visionGraph.courbe12->setVisible(false);
  }
  if(state13 == 1)
  {
    visionGraph.courbe13->attach(&visionGraph);
    visionGraph.courbe13->setVisible(true);
  }
  else
  {
    visionGraph.courbe13->detach();
    visionGraph.courbe13->setVisible(false);
  }
  if(state14 == 1)
  {
    visionGraph.courbe14->attach(&visionGraph);
    visionGraph.courbe14->setVisible(true);
  }
  else
  {
    visionGraph.courbe14->detach();
    visionGraph.courbe14->setVisible(false);
  }

  // update the display
  visionGraph.replot();

  // on recadre
  on_pushButton_18_clicked();

  // Reparation du zoom
  enableZoomMode(true); // demarrage du zoom

  // on recadre
  on_pushButton_18_clicked();

  // update the display
  visionGraph.replot();


////////////////////////////////////////
// enregistrement du tableau fichier avec les valeurs
// Enregistrement des valeurs dans un tableau
  // Tableau dosage
  affiche2B("Creation du tableau tableau_valeurs.CSV");
  tableaudosage();


}

////////////////////////////////////////
// affichage du graph
void QuadStar::on_pushButton_5_clicked()
{
/*
  if (visionGraph.isHidden() == 1)
  {
         visionGraph.resize(600,600);
         name_graph();
         visionGraph.show();
  }
  else
  {
         visionGraph.hide();
  }
*/


  name_graph();
  visionGraph.show();

  // update the display
  visionGraph.replot();

  // fenetre au premier plan
  visionGraph.raise();

}

////////////////////////////////////////
// affichage background
void QuadStar::on_pushButton_16_clicked()
{

  // on verifie que des valeurs ont bien ete mises en memoire
  if(visionGraph.val1 == NULL)
    return;

  if( state9 == 0)
  {
    state9 = 1;
    visionGraph.courbe9->attach(&visionGraph);
    visionGraph.courbe9->setVisible(true);
    ui.pushButton_16->setText("* Background *");
  }
  else
  {
    state9 = 0;
    visionGraph.courbe9->detach();
    visionGraph.courbe9->setVisible(false);
    ui.pushButton_16->setText("Background");
  }

  name_graph(); // on change le nom du graphique

  // update the display
  visionGraph.replot();

  // affichage de la fenetre du graphique
  if (visionGraph.isHidden() == 1)
  {
    on_pushButton_5_clicked();
  }


}

////////////////////////////////////////
// affichage cuve vide
void QuadStar::on_pushButton_17_clicked()
{

  // on verifie que des valeurs ont bien ete mises en memoire
  if(visionGraph.val1 == NULL)
    return;

  if( state10 == 0)
  {
    state10 = 1;
    visionGraph.courbe10->attach(&visionGraph);
    visionGraph.courbe10->setVisible(true);
    ui.pushButton_17->setText("* Cuve vide *");
  }
  else
  {
    state10 = 0;
    visionGraph.courbe10->detach();
    visionGraph.courbe10->setVisible(false);
    ui.pushButton_17->setText("Cuve vide");
  }

  name_graph(); // on change le nom du graphique

  // update the display
  visionGraph.replot();

  // affichage de la fenetre du graphique
  if (visionGraph.isHidden() == 1)
  {
    on_pushButton_5_clicked();
  }

}


////////////////////////////////////////
// affichage 0%
void QuadStar::on_pushButton_6_clicked()
{

  // on verifie que des valeurs ont bien ete mises en memoire
  if(visionGraph.val1 == NULL)
    return;

  if( state1 == 0)
  {
    state1 = 1;
    visionGraph.courbe1->attach(&visionGraph);
    visionGraph.courbe1->setVisible(true);
    ui.pushButton_6->setText("* Solution 0% (Solvant CCl4) *");
  }
  else
  {
    state1 = 0;
    visionGraph.courbe1->detach();
    visionGraph.courbe1->setVisible(false);
    ui.pushButton_6->setText("Solution 0% (Solvant CCl4)");
  }

  name_graph(); // on change le nom du graphique

  // update the display
  visionGraph.replot();

  // affichage de la fenetre du graphique
  if (visionGraph.isHidden() == 1)
  {
    on_pushButton_5_clicked();
  }

}

////////////////////////////////////////
// affichage 10%
void QuadStar::on_pushButton_7_clicked()
{
  // on verifie que des valeurs ont bien ete mises en memoire
  if(visionGraph.val1 == NULL)
    return;

  if( state2 == 0)
  {
    state2 = 1;
    visionGraph.courbe2->attach(&visionGraph);
    visionGraph.courbe2->setVisible(true);
    ui.pushButton_7->setText("* Solution 10% *");
  }
  else
  {
    state2 = 0;
    visionGraph.courbe2->detach();
    visionGraph.courbe2->setVisible(false);
    ui.pushButton_7->setText("Solution 10%");
  }

  name_graph(); // on change le nom du graphique

  // update the display
  visionGraph.replot();

  // affichage de la fenetre du graphique
  if (visionGraph.isHidden() == 1)
  {
    on_pushButton_5_clicked();
  }

}

////////////////////////////////////////
// affichage % inconnu
void QuadStar::on_pushButton_8_clicked()
{
  // on verifie que des valeurs ont bien ete mises en memoire
  if(visionGraph.val1 == NULL)
    return;

  if( state3 == 0)
  {
    state3 = 1;
    visionGraph.courbe3->attach(&visionGraph);
    visionGraph.courbe3->setVisible(true);
    ui.pushButton_8->setText("* Solution % inconnue *");
  }
  else
  {
    state3 = 0;
    visionGraph.courbe3->detach();
    visionGraph.courbe3->setVisible(false);
    ui.pushButton_8->setText("Solution % inconnue");
  }

  name_graph(); // on change le nom du graphique

  // update the display
  visionGraph.replot();

  // affichage de la fenetre du graphique
  if (visionGraph.isHidden() == 1)
  {
    on_pushButton_5_clicked();
  }

}

////////////////////////////////////////
// affichage 20%
void QuadStar::on_pushButton_9_clicked()
{
  // on verifie que des valeurs ont bien ete mises en memoire
  if(visionGraph.val1 == NULL)
    return;

  if( state4 == 0)
  {
    state4 = 1;
    visionGraph.courbe4->attach(&visionGraph);
    visionGraph.courbe4->setVisible(true);
    ui.pushButton_9->setText("* Solution 20% *");
  }
  else
  {
    state4 = 0;
    visionGraph.courbe4->detach();
    visionGraph.courbe4->setVisible(false);
    ui.pushButton_9->setText("Solution 20%");
  }

  name_graph(); // on change le nom du graphique

  // update the display
  visionGraph.replot();

  // affichage de la fenetre du graphique
  if (visionGraph.isHidden() == 1)
  {
    on_pushButton_5_clicked();
  }

}

////////////////////////////////////////
// affichage A
void QuadStar::on_pushButton_10_clicked()
{
  // on verifie que des valeurs ont bien ete mises en memoire
  if(visionGraph.val1 == NULL)
    return;

  if( state5 == 0)
  {
    state5 = 1;
    visionGraph.courbe5->attach(&visionGraph);
    visionGraph.courbe5->setVisible(true);
    ui.pushButton_10->setText("* Solution A *");
  }
  else
  {
    state5 = 0;
    visionGraph.courbe5->detach();
    visionGraph.courbe5->setVisible(false);
    ui.pushButton_10->setText("Solution A");
  }

  name_graph(); // on change le nom du graphique

  // update the display
  visionGraph.replot();

  // affichage de la fenetre du graphique
  if (visionGraph.isHidden() == 1)
  {
    on_pushButton_5_clicked();
  }

}


////////////////////////////////////////
// affichage B
void QuadStar::on_pushButton_11_clicked()
{
  // on verifie que des valeurs ont bien ete mises en memoire
  if(visionGraph.val1 == NULL)
    return;


  if( state6 == 0)
  {
    state6 = 1;
    visionGraph.courbe6->attach(&visionGraph);
    visionGraph.courbe6->setVisible(true);
    ui.pushButton_11->setText("* Solution B *");
  }
  else
  {
    state6 = 0;
    visionGraph.courbe6->detach();
    visionGraph.courbe6->setVisible(false);
    ui.pushButton_11->setText("Solution B");
  }

  name_graph(); // on change le nom du graphique

  // update the display
  visionGraph.replot();

  // affichage de la fenetre du graphique
  if (visionGraph.isHidden() == 1)
  {
    on_pushButton_5_clicked();
  }

}


////////////////////////////////////////
// affichage C
void QuadStar::on_pushButton_12_clicked()
{
  // on verifie que des valeurs ont bien ete mises en memoire
  if(visionGraph.val1 == NULL)
    return;


  if( state7 == 0)
  {
    state7 = 1;
    visionGraph.courbe7->attach(&visionGraph);
    visionGraph.courbe7->setVisible(true);
    ui.pushButton_12->setText("* Solution C *");
  }
  else
  {
    state7 = 0;
    visionGraph.courbe7->detach();
    visionGraph.courbe7->setVisible(false);
    ui.pushButton_12->setText("Solution C");
  }

  name_graph(); // on change le nom du graphique

  // update the display
  visionGraph.replot();

  // affichage de la fenetre du graphique
  if (visionGraph.isHidden() == 1)
  {
    on_pushButton_5_clicked();
  }

}


////////////////////////////////////////
// affichage D
void QuadStar::on_pushButton_13_clicked()
{
  // on verifie que des valeurs ont bien ete mises en memoire
  if(visionGraph.val1 == NULL)
    return;

  if( state8 == 0)
  {
    state8 = 1;
    visionGraph.courbe8->attach(&visionGraph);
    visionGraph.courbe8->setVisible(true);
    ui.pushButton_13->setText("* Solution D *");
  }
  else
  {
    state8 = 0;
    visionGraph.courbe8->detach();
    visionGraph.courbe8->setVisible(false);
    ui.pushButton_13->setText("Solution D");
  }

  name_graph(); // on change le nom du graphique

  // update the display
  visionGraph.replot();

  // affichage de la fenetre du graphique
  if (visionGraph.isHidden() == 1)
  {
    on_pushButton_5_clicked();
  }

}

////////////////////////////////////////
// affichage A - CCL4
void QuadStar::on_pushButton_4_clicked()
{
  // on verifie que des valeurs ont bien ete mises en memoire
  if(visionGraph.val1 == NULL)
    return;

  if( state11 == 0)
  {
    state11 = 1;
    visionGraph.courbe11->attach(&visionGraph);
    visionGraph.courbe11->setVisible(true);
    ui.pushButton_4->setText("* Sol A - CCL4 *");
  }
  else
  {
    state11 = 0;
    visionGraph.courbe11->detach();
    visionGraph.courbe11->setVisible(false);
    ui.pushButton_4->setText("Sol A - CCL4");
  }

  name_graph(); // on change le nom du graphique

  // update the display
  visionGraph.replot();

  // affichage de la fenetre du graphique
  if (visionGraph.isHidden() == 1)
  {
    on_pushButton_5_clicked();
  }

  recherche_pics_main();

}


////////////////////////////////////////
// affichage B - CCL4
void QuadStar::on_pushButton_14_clicked()
{
  // on verifie que des valeurs ont bien ete mises en memoire
  if(visionGraph.val1 == NULL)
    return;


  if( state12 == 0)
  {
    state12 = 1;
    visionGraph.courbe12->attach(&visionGraph);
    visionGraph.courbe12->setVisible(true);
    ui.pushButton_14->setText("* Sol B - CCL4 *");
  }
  else
  {
    state12 = 0;
    visionGraph.courbe12->detach();
    visionGraph.courbe12->setVisible(false);
    ui.pushButton_14->setText("Sol B - CCL4");
  }

  name_graph(); // on change le nom du graphique

  // update the display
  visionGraph.replot();

  // affichage de la fenetre du graphique
  if (visionGraph.isHidden() == 1)
  {
    on_pushButton_5_clicked();
  }

  recherche_pics_main();

}


////////////////////////////////////////
// affichage C - CCL4
void QuadStar::on_pushButton_19_clicked()
{
  // on verifie que des valeurs ont bien ete mises en memoire
  if(visionGraph.val1 == NULL)
    return;


  if( state13 == 0)
  {
    state13 = 1;
    visionGraph.courbe13->attach(&visionGraph);
    visionGraph.courbe13->setVisible(true);
    ui.pushButton_19->setText("* Sol C - CCL4 *");
  }
  else
  {
    state13 = 0;
    visionGraph.courbe13->detach();
    visionGraph.courbe13->setVisible(false);
    ui.pushButton_19->setText("Sol C - CCL4");
  }

  name_graph(); // on change le nom du graphique

  // update the display
  visionGraph.replot();

  // affichage de la fenetre du graphique
  if (visionGraph.isHidden() == 1)
  {
    on_pushButton_5_clicked();
  }

  recherche_pics_main();

}


////////////////////////////////////////
// affichage D - CCL4
void QuadStar::on_pushButton_20_clicked()
{
  // on verifie que des valeurs ont bien ete mises en memoire
  if(visionGraph.val1 == NULL)
    return;

  if( state14 == 0)
  {
    state14 = 1;
    visionGraph.courbe14->attach(&visionGraph);
    visionGraph.courbe14->setVisible(true);
    ui.pushButton_20->setText("* Sol D - CCL4*");
  }
  else
  {
    state14 = 0;
    visionGraph.courbe14->detach();
    visionGraph.courbe14->setVisible(false);
    ui.pushButton_20->setText("Sol D - CCL4");
  }

  name_graph(); // on change le nom du graphique

  // update the display
  visionGraph.replot();

  // affichage de la fenetre du graphique
  if (visionGraph.isHidden() == 1)
  {
    on_pushButton_5_clicked();
  }

  recherche_pics_main();

}


////////////////////////////////////////
// zoom ou dezoom
void QuadStar::mode_zoom(void)
{

  // on verifie que des valeurs ont bien ete mises en memoire
  if(visionGraph.val1 == NULL)
    return;

  // on zoom
  if(statezoom == 0)
  {
    statezoom=1;       
//    ui.pushButton_14->setText("Stop zoom");
    enableZoomMode(true);
  }

  // on dezoom
  else
  {
    statezoom=0;    
//    ui.pushButton_14->setText("Start zoom");
    enableZoomMode(false);
  }

}


////////////////////////////////////////
// recadre
void QuadStar::on_pushButton_18_clicked()
{

  // on verifie que des valeurs ont bien ete mises en memoire
  if(visionGraph.val1 == NULL)
    return;

  visionGraph.setAxisScale(QwtPlot::xBottom, 4400, 450);
  visionGraph.setAxisScale(QwtPlot::yLeft, visionGraph.valmin , visionGraph.valmax);

  // update the display
  visionGraph.replot();

}

////////////////////////////////////////
// impression
void QuadStar::on_pushButton_15_clicked()
{
  // creation d'une imprimante
  QPrinter printer;

  // on demande a choisir l'imprimante
  QPrintDialog *dlg = new QPrintDialog(&printer, this);
  if (dlg->exec() != QDialog::Accepted)
    return;

  QwtPlotPrintFilter filter;
  int options = QwtPlotPrintFilter::PrintAll;
  options &= ~QwtPlotPrintFilter::PrintBackground;
  options |= QwtPlotPrintFilter::PrintFrameWithScales;
  filter.setOptions(options);
  visionGraph.print(printer,filter);
}

///////////////////////////////////////////
// Activation ou desactivation du mode zoom
void QuadStar::enableZoomMode(bool on)
{
      if(d_zoomer[0] != NULL)
      {
        d_zoomer[0]->setEnabled(false);
        d_zoomer[0]->zoom(0);
        delete d_zoomer[0];
        d_zoomer[0] = NULL;
      }

      d_zoomer[0] = new Zoomer( QwtPlot::xBottom, QwtPlot::yLeft, visionGraph.canvas());
      d_zoomer[0]->setRubberBand(QwtPicker::RectRubberBand);
      d_zoomer[0]->setRubberBandPen(QColor(Qt::green));
      d_zoomer[0]->setTrackerMode(QwtPicker::ActiveOnly);
      d_zoomer[0]->setTrackerPen(QColor(Qt::white));
      d_zoomer[0]->setEnabled(true);
      d_zoomer[0]->zoom(0);

      if(d_zoomer[1] != NULL)
      {
        d_zoomer[1]->setEnabled(false);
        d_zoomer[1]->zoom(0);
        delete d_zoomer[1];
        d_zoomer[1] = NULL;
      }
      d_zoomer[1] = new Zoomer(QwtPlot::xTop, QwtPlot::yRight, visionGraph.canvas());
      d_zoomer[1]->setEnabled(true);
      d_zoomer[1]->zoom(0);


  // on donne les bonnes dimensions de la fenetre
  QwtDoubleRect largeur_zoom; // QRectF
  qreal val_top = visionGraph.valmin;
  qreal val_bottom = visionGraph.valmax;

  largeur_zoom = d_zoomer[0]->zoomBase  ();
//  send_commande2R("bottom : " + QString::number( largeur_zoom.top() ));
//  send_commande2R("top : " + QString::number( largeur_zoom.bottom() ));

  largeur_zoom.setBottom ( val_bottom );
  largeur_zoom.setTop ( val_top );
  d_zoomer[0]->setZoomBase ( largeur_zoom ); 
//  send_commande2R("bottom : " + QString::number( largeur_zoom.top() ));
//  send_commande2R("top : " + QString::number( largeur_zoom.bottom() ));

//  largeur_zoom = d_zoomer[0]->zoomBase  ();
//  send_commande2R("bottom : " + QString::number( largeur_zoom.top() ));
//  send_commande2R("top : " + QString::number( largeur_zoom.bottom() ));


///////////////////////
//marche pas, on est toujours a -10;10 quand on dezoom
/*
  d_zoomer[0]->setZoomBase  ( TRUE);  
  d_zoomer[1]->setZoomBase  ( TRUE);  
*/

/*
     if(on == true)
     {
       // initialisation du zoom
      d_zoomer[0] = new Zoomer( QwtPlot::xBottom, QwtPlot::yLeft, visionGraph.canvas());

      d_zoomer[0]->setRubberBand(QwtPicker::RectRubberBand);
      d_zoomer[0]->setRubberBandPen(QColor(Qt::green));
      d_zoomer[0]->setTrackerMode(QwtPicker::ActiveOnly);
      d_zoomer[0]->setTrackerPen(QColor(Qt::white));

      d_zoomer[1] = new Zoomer(QwtPlot::xTop, QwtPlot::yRight, visionGraph.canvas());

      d_zoomer[0]->setEnabled(true);
      d_zoomer[0]->zoom(0);
      d_zoomer[1]->setEnabled(true);
      d_zoomer[1]->zoom(0);

     }
     else if(on == false)
     {
      d_zoomer[0]->setEnabled(true);
      d_zoomer[0]->zoom(0);
      d_zoomer[1]->setEnabled(false);
      d_zoomer[1]->zoom(0);

      delete d_zoomer[0];
      delete d_zoomer[1];
     }
*/


}



///////////////////////////////////////////
// Donner un nom au graphique
void QuadStar::name_graph(void)
{

  int nb_spectres = 0;
  visionGraph.setTitle( "Spectres IR des solutions" );   

  if(state1 == 1)
    nb_spectres++;
  if(state2 == 1)
    nb_spectres++;
  if(state3 == 1)
    nb_spectres++;
  if(state4 == 1)
    nb_spectres++;
  if(state5 == 1)
    nb_spectres++;
  if(state6 == 1)
    nb_spectres++;
  if(state7 == 1)
    nb_spectres++;
  if(state8 == 1)
    nb_spectres++;
  if(state9 == 1)
    nb_spectres++;
  if(state10 == 1)
    nb_spectres++;
  if(state11 == 1)
    nb_spectres++;
  if(state12 == 1)
    nb_spectres++;
  if(state13 == 1)
    nb_spectres++;
  if(state14 == 1)
    nb_spectres++;

  QString title = "";

  if(state9 == 1)
  {
    title = "BACKGROUND";
    nb_spectres--;

    if( nb_spectres != 0)
      title = title + " + ";
  }

  if(state10 == 1)
  {
    title = title + "CUVE VIDE";
    nb_spectres--;

    if( nb_spectres != 0)
      title = title + " + ";
  }

  if(state1 == 1)
  {
    title = title + "Sol CCL4";
    nb_spectres--;

    if( nb_spectres != 0)
      title = title + " + ";
  }

  if(state2 == 1)
  {
    title = title + "Sol 10%";
    nb_spectres--;

    if( nb_spectres != 0)
      title = title + " + ";
  }

  if(state3 == 1)
  {
    title = title + "Sol inconnue";
    nb_spectres--;

    if( nb_spectres != 0)
      title = title + " + ";
  }

  if(state4 == 1)
  {
    title = title + "Sol 20%";
    nb_spectres--;

    if( nb_spectres != 0)
      title = title + " + ";
  }

  if(state5 == 1)
  {
    title = title + "Sol A";
    nb_spectres--;

    if( nb_spectres != 0)
      title = title + " + ";
  }

  if(state6 == 1)
  {
    title = title + "Sol B";
    nb_spectres--;

    if( nb_spectres != 0)
      title = title + " + ";
  }

  if(state7 == 1)
  {
    title = title + "Sol C";
    nb_spectres--;

    if( nb_spectres != 0)
      title = title + " + ";
  }

  if(state8 == 1)
  {
    title = title + "Sol D";
    nb_spectres--;
  }

  if(state11 == 1)
  {
    title = title + "Sol A-CCL4";
    nb_spectres--;

    if( nb_spectres != 0)
      title = title + " + ";
  }

  if(state12 == 1)
  {
    title = title + "Sol B-CCL4";
    nb_spectres--;

    if( nb_spectres != 0)
      title = title + " + ";
  }

  if(state13 == 1)
  {
    title = title + "Sol C-CCL4";
    nb_spectres--;

    if( nb_spectres != 0)
      title = title + " + ";
  }

  if(state14 == 1)
  {
    title = title + "Sol D-CCL4";
    nb_spectres--;
  }

  if(title != "")
    visionGraph.setTitle( title );   

}



////////////////////////////////////////
// Trouver les pics des solutions A, B, C et D
void QuadStar::on_pushButton_clicked()
{
  // on active la recherche des pics
  if(state_pics == 0)
  {
    state_pics=1;       
    ui.pushButton->setText("* Trouver les principaux pics *");
  }

  // on desactive la recherche des pics
  else
  {
    state_pics=0;    
    ui.pushButton->setText("Trouver les principaux pics");
  }

  recherche_pics_main();

}

////////////////////////////////////////
// On cherche les pics
void QuadStar::recherche_pics_main(void)
{
  // on initialise au besoin
  if(  visionGraph.marqueur1 == NULL)
    visionGraph.init_qwtplotmarker();

  // on detache toutes les lignes
  visionGraph.marqueur1->detach();
  visionGraph.marqueur2->detach();
  visionGraph.marqueur3->detach();
  visionGraph.marqueur4->detach();
  visionGraph.marqueur5->detach();
  visionGraph.marqueur6->detach();
  visionGraph.marqueur7->detach();
  visionGraph.marqueur8->detach();
  visionGraph.marqueur9->detach();
  visionGraph.marqueur10->detach();
  visionGraph.marqueur11->detach();
  visionGraph.marqueur12->detach();
  visionGraph.marqueur13->detach();
  visionGraph.marqueur14->detach();
  visionGraph.marqueur15->detach();
  visionGraph.marqueur16->detach();
  visionGraph.marqueur17->detach();
  visionGraph.marqueur18->detach();
  visionGraph.marqueur19->detach();

  // on regarde si la recherche de pics est activee
  if(state_pics == 0)
  {
    // update the display
    visionGraph.replot();

    return;
  }

  int nb_state = 0;
  if(state11 == 1) // solution A - CCL4
   nb_state++;
  if(state12 == 1) // solution B - CCL4
   nb_state++;
  if(state13 == 1) // solution C - CCL4
   nb_state++;
  if(state14 == 1) // solution D - CCL4
   nb_state++;

  // on recherche les pics
  if(nb_state == 1)
  {
    int choix_courbe = 0;
    if(state11 == 1) // on cherche sur la courbe11
      choix_courbe=11;
    if(state12 == 1) // on cherche sur la courbe12
      choix_courbe=12;
    if(state13 == 1) // on cherche sur la courbe13
      choix_courbe=13;
    if(state14 == 1) // on cherche sur la courbe14
      choix_courbe=14;

    int position_pic;

/*
    // moyenne
    position_pic=recherche_pics(2950 , 2975, choix_courbe);
    if(position_pic != -1)
    {
      visionGraph.marqueur1->setXValue(position_pic);
      visionGraph.marqueur1->setLabel(QString::number(position_pic));
      visionGraph.marqueur1->attach(&visionGraph);
    }

    // moyenne
    position_pic=recherche_pics(2860 , 2885, choix_courbe);
    if(position_pic != -1)
    {
      visionGraph.marqueur2->setXValue(position_pic);
      visionGraph.marqueur2->setLabel(QString::number(position_pic));
      visionGraph.marqueur2->attach(&visionGraph);
    }

    // moyenne
    position_pic=recherche_pics(1435 , 1470, choix_courbe);
    if(position_pic != -1)
    {
      visionGraph.marqueur3->setXValue(position_pic);
      visionGraph.marqueur3->setLabel(QString::number(position_pic));
      visionGraph.marqueur3->attach(&visionGraph);
    }
*/

    // Forte ==> CH3 ==> courbe B acetate d'ethyle
    position_pic=recherche_pics(1370 , 1385, choix_courbe, 0.2);
    if(position_pic != -1)
    {
      visionGraph.marqueur4->setXValue(position_pic);
      visionGraph.marqueur4->setLabel(QString::number(position_pic));
      visionGraph.marqueur4->attach(&visionGraph);
    }

/*
    // moyenne
    position_pic=recherche_pics(2915 , 2940, choix_courbe);
    if(position_pic != -1)
    {
      visionGraph.marqueur5->setXValue(position_pic);
      visionGraph.marqueur5->setLabel(QString::number(position_pic));
      visionGraph.marqueur5->attach(&visionGraph);
    }

    // moyenne
    position_pic=recherche_pics(2845 , 2870, choix_courbe);
    if(position_pic != -1)
    {
      visionGraph.marqueur6->setXValue(position_pic);
      visionGraph.marqueur6->setLabel(QString::number(position_pic));
      visionGraph.marqueur6->attach(&visionGraph);
    }

    // moyenne
    position_pic=recherche_pics(1440 , 1480, choix_courbe);
    if(position_pic != -1)
    {
      visionGraph.marqueur7->setXValue(position_pic);
      visionGraph.marqueur7->setLabel(QString::number(position_pic));
      visionGraph.marqueur7->attach(&visionGraph);
    }

    // variable
    position_pic=recherche_pics(3580 , 3670, choix_courbe, 0.03);
    if(position_pic != -1)
    {
      visionGraph.marqueur8->setXValue(position_pic);
      visionGraph.marqueur8->setLabel(QString::number(position_pic));
      visionGraph.marqueur8->attach(&visionGraph);
    }
*/
    // Forte ==> alcools ==> OH
    position_pic=recherche_pics(3230 , 3550, choix_courbe, 0.015);
    if(position_pic != -1)
    {
      visionGraph.marqueur9->setXValue(position_pic);
      visionGraph.marqueur9->setLabel(QString::number(position_pic));
      visionGraph.marqueur9->attach(&visionGraph);
    }

/*
    position_pic=recherche_pics(1260 , 1350, choix_courbe);
    if(position_pic != -1)
    {
      visionGraph.marqueur10->setXValue(position_pic);
      visionGraph.marqueur10->setLabel(QString::number(position_pic));
      visionGraph.marqueur10->attach(&visionGraph);
    }
*/

    // Forte ==> alcools ==> CO
    position_pic=recherche_pics(1000 , 1075, choix_courbe, 0.2);
    if(position_pic != -1)
    {
      visionGraph.marqueur11->setXValue(position_pic);
      visionGraph.marqueur11->setLabel(QString::number(position_pic));
      visionGraph.marqueur11->attach(&visionGraph);
    }

    // Forte ==> ctones ==> C=O
    position_pic=recherche_pics(1700 , 1725, choix_courbe, 0.2);
    if(position_pic != -1)
    {
      visionGraph.marqueur12->setXValue(position_pic);
      visionGraph.marqueur12->setLabel(QString::number(position_pic));
      visionGraph.marqueur12->attach(&visionGraph);
    }

    // Forte ==> cetones ==> CH3
    position_pic=recherche_pics(1355 , 1362, choix_courbe, 0.1);
    if(position_pic != -1)
    {
      visionGraph.marqueur13->setXValue(position_pic);
      visionGraph.marqueur13->setLabel(QString::number(position_pic));
      visionGraph.marqueur13->attach(&visionGraph);
    }

/*
    // acide carboxylique
    position_pic=recherche_pics(3500 , 3550, choix_courbe);
    if(position_pic != -1)
    {
      visionGraph.marqueur14->setXValue(position_pic);
      visionGraph.marqueur14->attach(&visionGraph);
    }
*/
/*
    // acide carboxylique
    position_pic=recherche_pics(2500 , 3300, choix_courbe);
    if(position_pic != -1)
    {
      visionGraph.marqueur15->setXValue(position_pic);
      visionGraph.marqueur15->attach(&visionGraph);
    }
*/
/*
    // acide carboxylique
    position_pic=recherche_pics(1700 , 1725, choix_courbe);
    if(position_pic != -1)
    {
      visionGraph.marqueur16->setXValue(position_pic);
      visionGraph.marqueur16->attach(&visionGraph);
    }
*/

    // Forte ==> esters ==> C=O
    position_pic=recherche_pics(1735 , 1750, choix_courbe, 0.2);
    if(position_pic != -1)
    {
      visionGraph.marqueur17->setXValue(position_pic);
      visionGraph.marqueur17->setLabel(QString::number(position_pic));
      visionGraph.marqueur17->attach(&visionGraph);
    }

    // Forte ==> esters ==> C-O
    position_pic=recherche_pics(1170 , 1250, choix_courbe, 0.2);
    if(position_pic != -1)
    {
      visionGraph.marqueur18->setXValue(position_pic);
      visionGraph.marqueur18->setLabel(QString::number(position_pic));
      visionGraph.marqueur18->attach(&visionGraph);
    }

    // Forte ==> ether ==> C-O
    position_pic=recherche_pics(1060 , 1150, choix_courbe, 0.2);
    if(position_pic != -1)
    {
      visionGraph.marqueur19->setXValue(position_pic);
      visionGraph.marqueur19->setLabel(QString::number(position_pic));
      visionGraph.marqueur19->attach(&visionGraph);
    }



  }


  // update the display
  visionGraph.replot();

}

////////////////////////////////////////
// On cherche les pics dans un intervale
int QuadStar::recherche_pics(int min , int max, int num_courbe, double seuil)
{
  int val_retour = -1; // on a rien trouve

// pour a quoi correspond min et max
// voir s'il y a un pic
// si oui, renvoyer la position du pic

  // on recherche les bornes
  int borne_min;
  int borne_max;

  borne_min = (4400 - min) / 2 + 1;
  borne_max = (4400 - max) / 2 - 1;

  // dans l'intervale, on cherche la valeur max
  double valeur_max=-10;
  int position = 0;
  int i=0;
  for(i = borne_max ; i <= borne_min ; i++ )
  {
    if(num_courbe == 11) // courbe A - CCL4
    {
      if(visionGraph.val11[i] > valeur_max)
      {
        valeur_max = visionGraph.val11[i];
        position = i;
      }

    }

    else if(num_courbe == 12) // courbe B - CCL4
    {
      if(visionGraph.val12[i] > valeur_max)
      {
        valeur_max = visionGraph.val12[i];
        position = i;
      }
    }

    else if(num_courbe == 13) // courbe C - CCL4
    {
      if(visionGraph.val13[i] > valeur_max)
      {
        valeur_max = visionGraph.val13[i];
        position = i;
      }
    }

    else if(num_courbe == 14) // courbe D - CCL4
    {
      if(visionGraph.val14[i] > valeur_max)
      {
        valeur_max = visionGraph.val14[i];
        position = i;
      }
    }

  }

  // on regarde si cela correspond a un pic
  if(num_courbe == 11) // courbe A
  {
    if(visionGraph.val11[position] - visionGraph.val11[position-10] > seuil && visionGraph.val11[position] - visionGraph.val11[position+10] > seuil )
        if(visionGraph.val11[position] > 0.1)
          if(visionGraph.val11[position] > visionGraph.val11[position-1] && visionGraph.val11[position] > visionGraph.val11[position+1])
            val_retour = 4400 - position*2;
  }
  else if(num_courbe == 12) // courbe B
  {
    if(visionGraph.val12[position] - visionGraph.val12[position-10] > seuil && visionGraph.val12[position] - visionGraph.val12[position+10] > seuil )
        if(visionGraph.val12[position] > 0.1)
          if(visionGraph.val12[position] > visionGraph.val12[position-1] && visionGraph.val12[position] > visionGraph.val12[position+1])
            val_retour = 4400 - position*2;
  }
  else if(num_courbe == 13) // courbe C
  {
    if(visionGraph.val13[position] - visionGraph.val13[position-10] > seuil && visionGraph.val13[position] - visionGraph.val13[position+10] > seuil )
        if(visionGraph.val13[position] > 0.1)
          if(visionGraph.val13[position] > visionGraph.val13[position-1] && visionGraph.val13[position] > visionGraph.val13[position+1])
            val_retour = 4400 - position*2;
  }
  else if(num_courbe == 14) // courbe D
  {
    if(visionGraph.val14[position] - visionGraph.val14[position-10] > seuil && visionGraph.val14[position] - visionGraph.val14[position+10] > seuil )
        if(visionGraph.val14[position] > 0.1)
          if(visionGraph.val14[position] > visionGraph.val14[position-1] && visionGraph.val14[position] > visionGraph.val14[position+1])
            val_retour = 4400 - position*2;
  }


  return val_retour;
}
